#include "time.hh"

#include "t/main.hh"

using namespace fatalmind;
//using fatalmind::POSIX::timespec;

void TEST_timespec_one() {
	POSIX::timespec<>();
	POSIX::timespec<>(2.3);
}

void TEST_timespec_calc() {
	POSIX::timespec<> c(1000);	
	POSIX::timespec<> d(2);
	POSIX::timespec<> q = d-c;
	assertEqualT(time_t, q.tv_sec, -998); 
	assertEqualT(long int, q.tv_nsec, 0); 
}


template<class Locking>
void PERF_compare_template() {
	POSIX::timespec<Locking> c(1000);	
	for (int i = 0; i < 1000000; ++i) {
		if (c < 2000) {
		}
	}
}

template<class Locking>
void PERF_plusequal_template() {
	POSIX::timespec<Locking> c(1000);
	POSIX::timespec<Locking> a(1);
	for (int i = 0; i < 1000000; ++i) {
			c += a;
	}
}

void TEST_PERF_compare_single() {
	PERF_compare_template<SingleThreadedModel<> >();
}

void TEST_PERF_compare_Multi() {
	PERF_compare_template<MultiThreadedModel<> >();
}

void TEST_PERF_plusequal_single() {
	PERF_plusequal_template<SingleThreadedModel<> > ();
}

void TEST_PERF_plusequal_Multi() {
	PERF_plusequal_template<MultiThreadedModel<> > ();
}

void TEST_PERF_plusequal_Mixed() {
	POSIX::timespec<SingleThreadedModel<> > c(1000);
	POSIX::timespec<MultiThreadedModel<> > a(1);
	for (int i = 0; i < 1000000; ++i) {
			c += a;
	}
}
